CREATE TYPE product_t AS OBJECT (name VARCHAR2(255), price NUMBER(30));

CREATE TYPE productSet_t AS TABLE OF product_t;

CREATE OR REPLACE FUNCTION FINDPRODUCTS2 (inprice in FLOAT,inkeyword in VARCHAR2)

RETURN productSet_t PIPELINED AS

l_cursor product_t;

BEGIN

	 FOR curr IN (SELECT NAME, PRICE FROM PRODUCT P WHERE PRICE < inprice AND DESCRIPTION LIKE '%' || inkeyword || '%') LOOP

	 	 l_cursor := product_t(curr.NAME, curr.PRICE);

		 PIPE ROW(l_cursor );

	 END LOOP;

	 RETURN;

END;

